#ifndef INTERFACE_H
#define INTERFACE_H

typedef struct cmdPara
{
    enum Type{MOVJ=1, MOVL};
    double m_velocity;
    double m_acc;
    double m_dec;
    double m_pl;
    double m_position[8];
    Type cmdType;
    cmdPara()
    {
        m_velocity = 0;
        m_acc = 0;
        m_dec = 0;
        m_pl = 0;
        for(int i=0;i<8;i++)
        {
            m_position[i] = 0;
        }
        cmdType = MOVJ;
    }
}cmdPara;

void connect_robot(char *ip);

void servo_power_on();

void servo_power_off();

void robot_movj(double *pos,int vel,int coord);

void robot_movl(double *pos,int vel,int coord);

void get_robot_running_state(int &state);

void start_jogging(int axis,bool direction);

void stop_jogging(int axis);

void set_dout(int port,int value);

void set_aout(int port,double value);

void get_dout(double *dout);

void get_din(double *din);

void get_aout(double *aout);

void get_ain(double *ain);

void get_current_position(double *pos);

void set_jogging_speed(int speed);

void continuous_motion_mode(int on);//0 close;1 open;

void send_continuous_motion_queue(cmdPara cmd[],unsigned int size);

#endif // INTERFACE_H
