#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "interface.h"
#include "qdebug.h"
MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pushButton_clicked()
{
    char ip[100] = "192.168.1.13";
    connect_robot(ip);
}

void MainWindow::on_pushButton_2_clicked()
{
    servo_power_on();
}

void MainWindow::on_pushButton_3_clicked()
{
    servo_power_off();
}

void MainWindow::on_pushButton_4_clicked()
{
    int state;
    get_robot_running_state(state);
    qDebug()<<"state "<<state;
}

void MainWindow::on_pushButton_5_clicked()
{
    double pos[6];
    get_current_position(pos);
    qDebug()<<"pos "<<pos[0]<<" "<<pos[1]<<" "<<pos[2]<<" "<<pos[3]<<" "<<pos[4]<<" "<<pos[5];
}

void MainWindow::on_pushButton_6_clicked()
{
    set_jogging_speed(50);
}

void MainWindow::on_pushButton_7_clicked()
{
    continuous_motion_mode(1);
}

void MainWindow::on_pushButton_8_clicked()
{
    continuous_motion_mode(0);
}

void MainWindow::on_pushButton_9_clicked()
{
    cmdPara cmd[2];
    cmd[0].cmdType = cmdPara::MOVJ;
    cmd[0].m_velocity = 10;
    cmd[0].m_acc = 10;
    cmd[0].m_dec = 10;
    cmd[0].m_pl = 1;
    cmd[0].m_position[0] = 0;
    cmd[0].m_position[1] = 0;
    cmd[0].m_position[2] = 1;
    cmd[0].m_position[3] = 2;
    cmd[0].m_position[4] = 3;
    cmd[0].m_position[5] = 4;
    cmd[0].m_position[6] = 5;
    cmd[0].m_position[7] = 6;

    cmd[1].cmdType = cmdPara::MOVL;
    cmd[1].m_velocity = 20;
    cmd[1].m_acc = 20;
    cmd[1].m_dec = 20;
    cmd[1].m_pl = 1;
    cmd[1].m_position[0] = 0;
    cmd[1].m_position[1] = 0;
    cmd[1].m_position[2] = 10;
    cmd[1].m_position[3] = 10;
    cmd[1].m_position[4] = 10;
    cmd[1].m_position[5] = 10;
    cmd[1].m_position[6] = 10;
    cmd[1].m_position[7] = 10;

    send_continuous_motion_queue(cmd,2);
}

void MainWindow::on_pushButton_10_clicked()
{
    double pos[6];
    pos[0] = 1;
    pos[1] = 2;
    pos[2] = 3;
    pos[3] = 4;
    pos[4] = 5;
    pos[5] = 6;
    robot_movj(pos,50,0);
}

void MainWindow::on_pushButton_11_clicked()
{
    double pos[6];
    pos[0] = 6;
    pos[1] = 6;
    pos[2] = 6;
    pos[3] = 6;
    pos[4] = 6;
    pos[5] = 6;
    robot_movl(pos,50,0);
}

void MainWindow::on_pushButton_12_clicked()
{
    double dout[16];
    double din[16];
    double aout[16];
    double ain[16];
    get_dout(dout);
    get_din(din);
    get_aout(aout);
    get_ain(ain);

    qDebug()<<"dout "<<dout[0]<<" "<<dout[1]<<" "<<dout[2]<<" "<<dout[3]<<" "<<dout[4]<<" "<<dout[5]<<" "<<dout[6]<<" "<<dout[7]<<" "<<dout[8]<<" "
           <<dout[9]<<" "<<dout[10]<<" "<<dout[11]<<" "<<dout[12]<<" "<<dout[13]<<" "<<dout[14]<<" "<<dout[15];

    qDebug()<<"din "<<din[0]<<" "<<din[1]<<" "<<din[2]<<" "<<din[3]<<" "<<din[4]<<" "<<din[5]<<" "<<din[6]<<" "<<din[7]<<" "<<din[8]<<" "
           <<din[9]<<" "<<din[10]<<" "<<din[11]<<" "<<din[12]<<" "<<din[13]<<" "<<din[14]<<" "<<din[15];

    qDebug()<<"aout "<<aout[0]<<" "<<aout[1]<<" "<<aout[2]<<" "<<aout[3]<<" "<<aout[4]<<" "<<aout[5]<<" "<<aout[6]<<" "<<aout[7]<<" "<<aout[8]<<" "
           <<aout[9]<<" "<<aout[10]<<" "<<aout[11]<<" "<<aout[12]<<" "<<aout[13]<<" "<<aout[14]<<" "<<aout[15];

    qDebug()<<"ain "<<ain[0]<<" "<<ain[1]<<" "<<ain[2]<<" "<<ain[3]<<" "<<ain[4]<<" "<<ain[5]<<" "<<ain[6]<<" "<<ain[7]<<" "<<ain[8]<<" "
           <<ain[9]<<" "<<ain[10]<<" "<<ain[11]<<" "<<ain[12]<<" "<<ain[13]<<" "<<ain[14]<<" "<<ain[15];
}

void MainWindow::on_pushButton_13_clicked()
{
    set_dout(1,1);
}

void MainWindow::on_pushButton_14_clicked()
{
    set_aout(1,1);
}

void MainWindow::on_pushButton_15_pressed()
{
    start_jogging(1,false);
}

void MainWindow::on_pushButton_15_released()
{
    stop_jogging(1);
}

void MainWindow::on_pushButton_16_pressed()
{
    start_jogging(1,true);
}

void MainWindow::on_pushButton_16_released()
{
    stop_jogging(1);
}

void MainWindow::on_pushButton_17_pressed()
{
    start_jogging(2,false);
}

void MainWindow::on_pushButton_17_released()
{
    stop_jogging(2);
}

void MainWindow::on_pushButton_18_pressed()
{
    start_jogging(2,true);
}

void MainWindow::on_pushButton_18_released()
{
    stop_jogging(2);
}

void MainWindow::on_pushButton_19_pressed()
{
    start_jogging(3,false);
}

void MainWindow::on_pushButton_19_released()
{
    stop_jogging(3);
}

void MainWindow::on_pushButton_20_pressed()
{
    start_jogging(3,true);
}

void MainWindow::on_pushButton_20_released()
{
    stop_jogging(3);
}

void MainWindow::on_pushButton_21_pressed()
{
    start_jogging(4,false);
}

void MainWindow::on_pushButton_21_released()
{
    stop_jogging(4);
}

void MainWindow::on_pushButton_22_pressed()
{
    start_jogging(4,true);
}

void MainWindow::on_pushButton_22_released()
{
    stop_jogging(4);
}

void MainWindow::on_pushButton_23_pressed()
{
    start_jogging(5,false);
}

void MainWindow::on_pushButton_23_released()
{
    stop_jogging(5);
}

void MainWindow::on_pushButton_24_pressed()
{
    start_jogging(5,true);
}

void MainWindow::on_pushButton_24_released()
{
    stop_jogging(5);
}

void MainWindow::on_pushButton_25_pressed()
{
    start_jogging(6,false);
}

void MainWindow::on_pushButton_25_released()
{
    stop_jogging(6);
}

void MainWindow::on_pushButton_26_pressed()
{
    start_jogging(6,true);
}

void MainWindow::on_pushButton_26_released()
{
    stop_jogging(6);
}
